<?php
namespace Controllers; 

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;

class Gop00800TaxaAdministraivaController extends \Teknisa\Libs\Controller\CRUD{
    protected $dataSourceManager;
    protected $connection;
    protected $newCode;
    protected $environment;
    protected $service;


    public function __construct($crudService,  $environment, $dataSourceManager, $connection, $newCode, $service) {
        parent::__construct($crudService, $environment);

        $this->environment = $environment;
        $this->dataSourceManager    = $dataSourceManager;
        $this->connection = $connection;
        $this->newCode = $newCode;
        $this->service = $service;
    }
    
    public function saveTaxaAdministrativa(DTO\Request $request, DTO\Response $response ){
       //$dados = $request->getParameter("DataSet");
        $dados = $request->getDataSet();
        if(!empty($dados)){
            $rows = $dados->getRows();
            if($rows[0]["widgetName"] == "gop00800_taxa_administrativa_regional"){
                $nmtabela = "TAXAADMREGGES";
                $cdcampo = "CDAREAGERE";
            }else{
                $nmtabela = "TAXAADMFILGES";
                $cdcampo = "CDFILIAL";
            }
            
            if(!empty($rows)){
               foreach($rows as $row){
                    $parametros =  array(
                        ("P_NR".$nmtabela) => intval($this->newCode->getCodeByTableName($nmtabela, $this->environment->getNrorg())),
                        ("P_" . $cdcampo) => $row[$cdcampo],
                        "P_CDANO" => $row["CDANO"],
                        "P_NRORG" => $this->environment->getNrorg(),
                        "P_VRMES01" => $row["VRMES01"],
                        "P_VRMES02" => $row["VRMES02"],
                        "P_VRMES03" => $row["VRMES03"],
                        "P_VRMES04" => $row["VRMES04"],
                        "P_VRMES05" => $row["VRMES05"],
                        "P_VRMES06" => $row["VRMES06"],
                        "P_VRMES07" => $row["VRMES07"],
                        "P_VRMES08" => $row["VRMES08"],
                        "P_VRMES09" => $row["VRMES09"],
                        "P_VRMES10" => $row["VRMES10"],
                        "P_VRMES11" => $row["VRMES11"],
                        "P_VRMES12" => $row["VRMES12"],
                        "P_DTINCLUSAO" => $this->crudService->getEnvironment()->getCurrentTime()->format("d/m/Y"),
                        "P_CDOPERINCLUSAO" => $this->environment->getCdOperador(),
                        "P_NRORGINCLUSAO" => $this->environment->getNrorg()
                    );
                    $this->service->insertTaxaAdministrativa($parametros, $nmtabela, $cdcampo);
               }
            } 
        }
    }
    
    public function updateTaxaAdministrativa(DTO\Request $request, DTO\Response $response ){
        $dados = $request->getDataSet();
        if(!empty($dados)){
            $rows = $dados->getRows();
            if($rows[0]["widgetName"] == "gop00800_taxa_administrativa_regional"){
                $nmtabela = "TAXAADMREGGES";
            }else{
                $nmtabela = "TAXAADMFILGES";
            }
            if(!empty($rows)){     
                foreach($rows as $row){
                    $params =  array(
                        ("P_NR".$nmtabela) => $row["NR".$nmtabela],
                        "P_VRMES01" => $row["VRMES01"],
                        "P_VRMES02" => $row["VRMES02"],
                        "P_VRMES03" => $row["VRMES03"],
                        "P_VRMES04" => $row["VRMES04"],
                        "P_VRMES05" => $row["VRMES05"],
                        "P_VRMES06" => $row["VRMES06"],
                        "P_VRMES07" => $row["VRMES07"],
                        "P_VRMES08" => $row["VRMES08"],
                        "P_VRMES09" => $row["VRMES09"],
                        "P_VRMES10" => $row["VRMES10"],
                        "P_VRMES11" => $row["VRMES11"],
                        "P_VRMES12" => $row["VRMES12"],
                        "P_DTULTATU" => $this->crudService->getEnvironment()->getCurrentTime()->format("d/m/Y"),
                        "P_NRORGULTATU" => $this->environment->getNrorg(),
                        "P_CDOPERULTATU" => $this->environment->getCdOperador()
                    );
                    $this->service->updateTaxaAdministrativa($params, $nmtabela);
                }
            } 
        }
    }

    public function cadastramentoAutomatico(DTO\Request $request, DTO\Response $response ){
        $dados = $request->getDataSet();
        
        if(!empty($dados)){
            $rows = $dados->getRows();
            if(!empty($rows)){
                if(empty($rows[0]["NMAREAGERE"])){
                    $nmtabela = "TAXAADMFILGES";
                    $nmtabelaLowKey = "taxaadmfilges";
                    $cdcampo = "CDFILIAL";
                    $nmcampo = "NMFILIAL";
                }else{
                    $nmtabela = "TAXAADMREGGES";
                    $nmtabelaLowKey = "taxaadmregges";
                    $cdcampo = "CDAREAGERE";
                    $nmcampo = "NMAREAGERE";
                }
                $row = clone $rows[0];
                $anos = $rows[0]["ANOS"];
                
                foreach($anos as $ano){
                    foreach($rows[0][$nmcampo] as $valueCdcampo){
                        
                        $row[$cdcampo] = $valueCdcampo;
                        $row["CDANO"] = $ano;
                        $conditions = array(
                            array( "columnName" => $cdcampo, "operator" => "=", "value" => $valueCdcampo),
                            array( "columnName" => "CDANO", "operator" => "=", "value" => $ano
                            )
                        );
                        $dataSet = $this->crudService->getFilteredDataSet($nmtabelaLowKey, $conditions);

                        if(count($dataSet->getRows()) == 0){
                            $this->insertCadAuto($nmtabela, $cdcampo, $rows, $valueCdcampo, $ano);

                        }else {
                            $this->updateCadAuto($nmtabela, $cdcampo, $rows, $dataSet->getRows()[0]["NR".$nmtabela]);
                        }
                    }
                    
                }
            } 
        }
    }
    
    private function insertCadAuto($nmtabela, $cdcampo, $rows, $valueCdcampo, $ano){
        $stringMeses = "";
        $stringParamMeses = "";
        
        if(!empty($rows[0]["TAXAADMINMATRIZ"]) || $rows[0]["TAXAADMINMATRIZ"] == 0){
            $taxaadminmatriz = $rows[0]["TAXAADMINMATRIZ"];
        }else{
            $taxaadminmatriz = null;
        }
        
        foreach ($rows[0]["MESES"] as $nrMes) {
            $stringMeses = $stringMeses . ", VRMES".$nrMes;
            $stringParamMeses = $stringParamMeses . ", " . ":P_TAXAADM";
        }
        $params = array(
            ("P_NR" . $nmtabela) => intval($this->newCode->getCodeByTableName($nmtabela, $this->environment->getNrorg())),
            ("P_" . $cdcampo) => $valueCdcampo,
            "P_CDANO" => $ano,
            "P_NRORG" => $this->environment->getNrorg(),
            "P_DTINCLUSAO" => $this->crudService->getEnvironment()->getCurrentTime()->format("d/m/Y"),
            "P_CDOPERINCLUSAO" => $this->environment->getCdOperador(),
            "P_NRORGINCLUSAO" => $this->environment->getNrorg(),
            "P_TAXAADM" => $taxaadminmatriz
        );
       
        $this->service->insertCadAuto($params, $nmtabela, $cdcampo, $stringMeses, $stringParamMeses);
    }
    
    private function updateCadAuto($nmtabela, $cdcampo, $rows, $nrRow){
        $stringMeses = "";
        
        if(!empty($rows[0]["TAXAADMINMATRIZ"]) || $rows[0]["TAXAADMINMATRIZ"] == 0){
            $taxaadminmatriz = $rows[0]["TAXAADMINMATRIZ"];
        }else{
            $taxaadminmatriz = null;
        }
        foreach ($rows[0]["MESES"] as $nrMes) {
            $stringMeses = $stringMeses . ", VRMES" . $nrMes . " = :P_TAXAADM";
        }
        $params =  array(
            ("P_NR" . $nmtabela) => $nrRow,
            "P_DTULTATU" => $this->crudService->getEnvironment()->getCurrentTime()->format("d/m/Y"),
            "P_NRORGULTATU" => $this->environment->getNrorg(),
            "P_CDOPERULTATU" => $this->environment->getCdOperador(),
            "P_TAXAADM" => $taxaadminmatriz
        );
        $this->service->updateCadAuto($params, $nmtabela, $stringMeses);
    }

}